## qdevelop 0.25.2

=== CMakeLists.txt ===
# qdevelop CMakeLists.txt
# 
# To build qdevelop, you will need cmake 2.4.3 (should also work with 2.4.0 and above
# but not tested). To build the application run this commands:
# 
#	mkdir cbuild
#	cd cbuild
#	cmake ../
#	make
# 
# Please indent this file using tabs, and set the tabs to 8 spaces :)
# 
# If you don't konw cmake, here are some links for you:
# 	http://wiki.qtcentre.org/index.php?title=Compiling_Qt4_apps_with_CMake
# 	http://qtnode.net/wiki/Qt_with_cmake#cmake_for_Qt_4

PROJECT(QDevelop)
CMAKE_MINIMUM_REQUIRED(VERSION 2.4.0)
SET(QDEV	"qdevelop"	CACHE STRING "Name of the executeable")

# verbose - off
# SET( CMAKE_VERBOSE_MAKEFILE  ON )

# do optimizations on GCC based compilers
# if you want to speed up compilations, set this to -O0,
# which reduces compilation time from 2:30 to 1:30 on my system
SET( OPTIMIZATION_FLAGS "-O2")

## TODO mmmm....
# CHECK_C_COMPILER_FLAG( ${OPTIMIZATION_FLAGS} HAS_OPTIMIZATION_FLAGS )
# if (HAS_OPTIMIZATION_FLAGS)
# 	ADD_DEFINITIONS( ${OPTIMIZATION_FLAGS} )
# endif (HAS_OPTIMIZATION_FLAGS)

ADD_DEFINITIONS( ${OPTIMIZATION_FLAGS} )


# input files
SET( qdevelop_UIS
	ui/about.ui 
	ui/addexistant.ui
	ui/addnew.ui
	ui/addnewclass.ui
	ui/addnewclassmethod.ui
	ui/addnewclassvariable.ui
	ui/addsetget.ui
	ui/addscope.ui
	ui/breakpointcondition.ui
	ui/exechoice.ui
	ui/findfiles.ui
	ui/findwidget.ui
	ui/gotoline.ui
	ui/main.ui
	ui/newimplementation.ui
	ui/newproject.ui
	ui/newvariable.ui
	ui/options.ui
	ui/openfile.ui
	ui/parameters.ui
	ui/projectpropertie.ui
	ui/promptreplace.ui
	ui/registers.ui
	ui/replace.ui
	ui/shortcuts.ui
	ui/subclassing.ui
	ui/toolsControl.ui
	ui/warning.ui
)

SET( qdevelop_SRCS
	src/InitCompletion.cpp
	src/QIComplete/parse.cpp
	src/QIComplete/readtags.cpp
	src/QIComplete/tree.cpp
	src/addexistantimpl.cpp
	src/addnewimpl.cpp
	src/addnewclassimpl.cpp
	src/addscopeimpl.cpp
	src/addsetgetimpl.cpp 
	src/addnewclassmethodimpl.cpp
	src/addnewclassvariableimpl.cpp
	src/assistant.cpp
	src/build.cpp
	src/cpphighlighter.cpp
	src/debug.cpp
	src/designer.cpp
	src/editor.cpp
	src/findfileimpl.cpp
	src/lineedit.cpp
	src/logbuild.cpp
	src/linenumbers.cpp
	src/main.cpp
	src/mainimpl.cpp
	src/misc.cpp
	src/newprojectimpl.cpp
	src/optionsimpl.cpp
	src/openfileimpl.cpp 
	src/parametersimpl.cpp
	src/projectmanager.cpp
	src/projectpropertieimpl.cpp
	src/promptreplaceimpl.cpp
	src/registersimpl.cpp
	src/replaceimpl.cpp
	src/selectionborder.cpp
	src/shortcutsimpl.cpp
	src/stackimpl.cpp
	src/subclassingimpl.cpp
	src/tabwidget.cpp
	src/textEdit.cpp
	src/treeclasses.cpp
	src/treeproject.cpp
	src/toolscontrolimpl.cpp
)

SET( qdevelop_MOC_HDRS	
	src/InitCompletion.h
	src/addexistantimpl.h
	src/addnewimpl.h
	src/addnewclassimpl.h
	src/addnewclassmethodimpl.h
	src/addnewclassvariableimpl.h
	src/addscopeimpl.h
	src/addsetgetimpl.h
	src/assistant.h
	src/build.h
	src/debug.h
	src/editor.h
	src/findfileimpl.h
	src/linenumbers.h
	src/logbuild.h
	src/mainimpl.h
	src/newprojectimpl.h
	src/optionsimpl.h
	src/openfileimpl.h
	src/parametersimpl.h
	src/projectmanager.h
	src/projectpropertieimpl.h
	src/promptreplaceimpl.h
	src/registersimpl.h
	src/replaceimpl.h
	src/shortcutsimpl.h
	src/stackimpl.h
	src/subclassingimpl.h
	src/tabwidget.h
	src/textEdit.h
	src/treeclasses.h
	src/treeproject.h
	src/toolscontrolimpl.h
)

SET( qdevelop_RCS
	QDevelop.rc
)

SET( qdevelop_RESOURCES
	resources/resources.qrc
)


FIND_PACKAGE( Qt4 REQUIRED )
INCLUDE(${QT_USE_FILE})

SET( QT_USE_QTASSISTANT )
SET( QT_USE_QTDESIGNER )
SET( QT_USE_QTNETWORK )
SET( QT_USE_QTSQL )
SET( QT_USE_QTXML )
SET( QT_USE_QTUITOOLS )

# qt4 definitinos
QT4_WRAP_UI       ( qdevelop_UIS_H        ${qdevelop_UIS}       )
QT4_WRAP_CPP      ( qdevelop_MOC_SRCS     ${qdevelop_MOC_HDRS}  )
QT4_ADD_RESOURCES ( qdevelop_RESOURCES    ${qdevelop_RESOURCES} )
QT4_AUTOMOC       ( ${qdevelop_SRCS}                            )

# definitions for the project
ADD_DEFINITIONS(
	-Wall 
	-DQT_NO_DEBUG
	${QT_DEFINITIONS}
)

# include directories
INCLUDE_DIRECTORIES(
	${QT_INCLUDES}
	${QT_INCLUDE_DIR}/QtUiTools
	${CMAKE_BINARY_DIR}
	.
	src
	src/ui 
)

IF( MINGW )
	# resource compilation for MinGW
	ADD_CUSTOM_COMMAND( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/qdevelop_ico.o
		COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR} -i${CMAKE_CURRENT_SOURCE_DIR}/QDevelop.rc 
			-o ${CMAKE_CURRENT_BINARY_DIR}/qdevelop_ico.o )
	SET( qdevelop_SRCS ${qdevelop_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/qdevelop_ico.o)
	SET( QT_UITOOLSLIB QtUiTools QtDesigner4  )
ELSE( MINGW )
	SET(qdevelop_SRCS	${qdevelop_SRCS} QDevelop.rc)
	SET(QT_UITOOLSLIB	${QT_QTUITOOLS_LIBRARY} QtDesigner )
ENDIF( MINGW )

# the main build target
ADD_EXECUTABLE( ${QDEV}
	${qdevelop_SRCS} 
	${qdevelop_UIS_H} 
	${qdevelop_MOC_SRCS} 
	${qdevelop_UIS} 
	${qdevelop_RESOURCES} 
)

IF( MINGW )
	SET_TARGET_PROPERTIES( ${QDEV} PROPERTIES LINK_FLAGS "-mwindows" )
ENDIF( MINGW )

TARGET_LINK_LIBRARIES( ${QDEV}
	${QT_UITOOLSLIB} 
	${QT_QTSQL_LIBRARY}
	${QT_LIBRARIES}
	${QT_QTXML_LIBRARY}
	${QT_QTNETWORK_LIBRARY}
)

## qdevelop 0.25.2+svn080826

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,9 +58,8 @@
 	ui/openfile.ui
 	ui/parameters.ui
 	ui/projectpropertie.ui
-	ui/promptreplace.ui
 	ui/registers.ui
-	ui/replace.ui
+	ui/replacewidget.ui
 	ui/shortcuts.ui
 	ui/subclassing.ui
 	ui/toolsControl.ui
@@ -98,9 +97,7 @@
 	src/parametersimpl.cpp
 	src/projectmanager.cpp
 	src/projectpropertieimpl.cpp
-	src/promptreplaceimpl.cpp
 	src/registersimpl.cpp
-	src/replaceimpl.cpp
 	src/selectionborder.cpp
 	src/shortcutsimpl.cpp
 	src/stackimpl.cpp
@@ -135,9 +132,7 @@
 	src/parametersimpl.h
 	src/projectmanager.h
 	src/projectpropertieimpl.h
-	src/promptreplaceimpl.h
 	src/registersimpl.h
-	src/replaceimpl.h
 	src/shortcutsimpl.h
 	src/stackimpl.h
 	src/subclassingimpl.h

## qdevelop 0.27.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,6 @@
 # endif (HAS_OPTIMIZATION_FLAGS)
 
 ADD_DEFINITIONS( ${OPTIMIZATION_FLAGS} )
-
 
 # input files
 SET( qdevelop_UIS
@@ -217,3 +216,5 @@
 	${QT_QTXML_LIBRARY}
 	${QT_QTNETWORK_LIBRARY}
 )
+
+INSTALL (TARGETS ${QDEV} RUNTIME DESTINATION bin)

## qdevelop 0.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -150,6 +150,25 @@
 	resources/resources.qrc
 )
 
+SET( qdevelop_TS
+	resources/translations/QDevelop_Chinese.ts
+	resources/translations/QDevelop_Czech.ts
+	resources/translations/QDevelop_Dutch.ts
+	resources/translations/QDevelop_French.ts
+	resources/translations/QDevelop_German.ts
+	resources/translations/QDevelop_Hungarian.ts
+	resources/translations/QDevelop_Italian.ts
+	resources/translations/QDevelop_Japanese.ts
+	resources/translations/QDevelop_Polish.ts
+	resources/translations/QDevelop_Portuguese.ts
+	resources/translations/QDevelop_Russian.ts
+	resources/translations/QDevelop_Spanish.ts
+	resources/translations/QDevelop_Turkish.ts
+	resources/translations/QDevelop_Ukrainian.ts
+	resources/translations/QDevelop_Vietnamese.ts
+
+)
+
 
 FIND_PACKAGE( Qt4 REQUIRED )
 INCLUDE(${QT_USE_FILE})
@@ -166,6 +185,7 @@
 QT4_WRAP_CPP      ( qdevelop_MOC_SRCS     ${qdevelop_MOC_HDRS}  )
 QT4_ADD_RESOURCES ( qdevelop_RESOURCES    ${qdevelop_RESOURCES} )
 QT4_AUTOMOC       ( ${qdevelop_SRCS}                            )
+QT4_ADD_TRANSLATION ( qdevelop_QM         ${qdevelop_TS}        )
 
 # definitions for the project
 ADD_DEFINITIONS(
@@ -203,6 +223,7 @@
 	${qdevelop_MOC_SRCS} 
 	${qdevelop_UIS} 
 	${qdevelop_RESOURCES} 
+	${qdevelop_QM}
 )
 
 IF( MINGW )
@@ -217,4 +238,57 @@
 	${QT_QTNETWORK_LIBRARY}
 )
 
+# Plugins support
+
+IF (AUTOPLUGINS)
+	FILE (GLOB PLUGINS ${QDevelop_SOURCE_DIR}/plugins/*)
+	FOREACH (PLG ${PLUGINS})
+		STRING (REGEX MATCH \\.svn FAIL ${PLG})
+		STRING (COMPARE EQUAL "${FAIL}" "" IS_EMPTY)
+		IF (IS_EMPTY)
+			SET (PLG_HXX "")
+			SET (PLG_CXX "")
+			SET (PLG_UI "")
+			SET (PLG_MOC "")
+			SET (PLG_UIC "")
+			SET (PLG_TS "")
+			SET (PLG_QM "")
+		
+			STRING (REPLACE "${QDevelop_SOURCE_DIR}/plugins/" "" PLG_NAME ${PLG})
+			MESSAGE (STATUS "Preparing plugin ${PLG_NAME} for building")
+		
+			FILE (GLOB PLG_HXX ${PLG}/*.h)
+			FILE (GLOB PLG_CXX ${PLG}/*.cpp)
+			FILE (GLOB PLG_UI ${PLG}/*.ui)
+			FILE (GLOB PLG_TS ${PLG}/translations/*.ts)
+			QT4_ADD_TRANSLATION (PLG_QM ${PLG_TS})
+		
+			QT4_WRAP_CPP (PLG_MOC ${PLG_HXX})
+			QT4_WRAP_UI (PLG_UIC ${PLG_UI})
+		
+			ADD_LIBRARY (${PLG_NAME} SHARED ${PLG_CXX} ${PLG_MOC} ${PLG_UIC} ${PLG_QM})
+			TARGET_LINK_LIBRARIES (${PLG_NAME} ${QT_UITOOLSLIB} 
+				${QT_QTSQL_LIBRARY}
+				${QT_LIBRARIES}
+				${QT_QTXML_LIBRARY}
+				${QT_QTNETWORK_LIBRARY})
+			SET_TARGET_PROPERTIES (${PLG_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY plugins LIBRARY_OUTPUT_DIRECTORY plugins)
+			ADD_DEPENDENCIES (${PLG_NAME} ${QDEV})
+		
+			IF (WIN32)
+				INSTALL (TARGETS ${PLG_NAME} DESTINATION bin/plugins)
+				INSTALL (FILES ${PLG_QM} DESTINATION translations/${PLG_NAME})
+			ELSE (NOT WIN32)
+				INSTALL (TARGETS ${PLG_NAME} DESTINATION lib/qdevelop/plugins)
+				INSTALL (FILES ${PLG_QM} DESTINATION lib/qdevelop/translations/${PLG_NAME})
+			ENDIF (WIN32)
+		ENDIF (IS_EMPTY)
+	ENDFOREACH (PLG)
+ENDIF (AUTOPLUGINS)
+
 INSTALL (TARGETS ${QDEV} RUNTIME DESTINATION bin)
+IF (WIN32)
+	INSTALL (FILES ${qdevelop_QM} DESTINATION translations)
+ELSE (NOT WIN32)
+	INSTALL (FILES ${qdevelop_QM} DESTINATION lib/qdevelop/translations)
+ENDIF (WIN32)

=== debian/changelog ===
qdevelop (0.28-0ubuntu1) maverick; urgency=low

  * New upstream version.
  * Build qdevelop plugins.
  * Switch to source format 3.0 (quilt).
  * Switch from cdbs to dh7 tiny.
  * Fix watch file.
  * Bump debian/compat to 7.
  * Bump Standards-Version to 3.8.4.
  * Update homepage.
  * Drop Vcs-* control fields as it's not used anymore.
  * Add fix_ftbfs_qt47.patch to fix FTBFS with Qt 4.7.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sat, 26 Jun 2010 20:26:05 +0200

qdevelop (0.27.4-0ubuntu2) lucid; urgency=low

  * Fix build-buttons always being disabled. (LP: #471775)
    - Fix from upstream; applied inline.
    - http://code.google.com/p/qdevelop/source/detail?r=459

 -- Andreas Wenning <awen@awen.dk>  Tue, 03 Nov 2009 15:57:28 +0100

qdevelop (0.27.4-0ubuntu1) jaunty; urgency=low

  * New upstream release. (LP: 354716)

 -- Andreas Wenning <awen@awen.dk>  Fri, 03 Apr 2009 20:37:33 +0200

qdevelop (0.26.1+svn090210-0ubuntu1) jaunty; urgency=low

  * New upstream SVN snapshot (LP: #326666, #243151)
  * debian/patches/kubuntu_01_add_qt4_suffix.patch:
    - removed, applied upstream
  * removed debian/patches since we don't ship patches anymore
  * debian/rules:
    - removed quilt build-dep
    - simplified get-orig-svn target: use svn export instead of svn co and rm
  * debian/copyright:
    - added new contributor Divius O'Naerro
    - fix copyright-with-old-dh-make-debian-copyright
  * debian/control:
    - fix debhelper-but-no-misc-depends

 -- Guillaume Martres <smarter@ubuntu.com>  Tue, 10 Feb 2009 11:56:04 +0100

qdevelop (0.26.1-0ubuntu1) jaunty; urgency=low

  * New upstream release
  * debian/rules:
    - switch to quilt for patching
    - removed get-orig-source as qdevelop is now distributed with tar.gz
  * debian/control:
   - added build-dep on quilt
  * added debian/patches/series
  * debian/patches/kubuntu_01_add_qt4_suffix.patch:
    - Don't create a QFileInfo object to only use it one time.
      Instead, directly calls the exists() function on
      QFileInfo("/etc/debian_version")

 -- Guillaume Martres <smarter@ubuntu.com>  Tue, 11 Nov 2008 16:15:27 +0100

qdevelop (0.25.2+svn080826-0ubuntu2) intrepid; urgency=low

  * Fixed FTBFS due to debian/patches/kubuntu_01_add_qt4_suffix.patch

 -- Guillaume Martres <smarter@ubuntu.com>  Wed, 27 Aug 2008 00:26:56 +0200

qdevelop (0.25.2+svn080826-0ubuntu1) intrepid; urgency=low

  * New upstream snapshot
  * debian/control:
    - Bumped Standards-Version to 3.8.0.1
  * debian/rules:
    - includes /usr/share/cdbs/1/rules/simple-patchsys.mk
  * added debian/patches/kubuntu_01_add_qt4_suffix.patch:
    - add "-qt4" suffix to tools like qmake or designer

 -- Guillaume Martres <smarter@ubuntu.com>  Tue, 26 Aug 2008 20:08:11 +0200

qdevelop (0.25.2+svn080522-0ubuntu1) intrepid; urgency=low

  * New upstream snapshot, fix bugs with Qt4.4
  * debian/rules:
    - added get-orig-svn target
  * debian/control:
    - added Depends on libqt4-sql-sqlite
    - added Vcs-* fields

 -- Guillaume Martres <smarter@ubuntu.com>  Fri, 23 May 2008 18:11:50 +0200

qdevelop (0.25.2-0ubuntu1) hardy; urgency=low

  * Initial release based on Daniel Rocher package (LP: #120739)

 -- Guillaume Martres <smarter@ubuntu.com>  Sun, 10 Feb 2008 14:00:24 +0100

=== debian/control ===
Source: qdevelop
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Guillaume Martres <smarter@ubuntu.com>
Build-Depends: debhelper (>= 7.4.10~), libqt4-dev, cmake
Standards-Version: 3.8.4
Homepage: http://biord-software.org/qdevelop/

Package: qdevelop
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite
Recommends: gdb, exuberant-ctags, qt4-designer, qt4-dev-tools
Description: A development environment entirely dedicated to Qt4
 It consists of a Qt project manager, a source code editor, 
 build-automation tools by calling make command, and the gdb debugger.
 .
 QDevelop aims to be easy to use and does not try to compete with more
 complete tools, like kdevelop, which are often too complex. Its goal
 is simplicity, powerfulness and a same interface on all platforms.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --parallel $@

override_dh_auto_configure:
	dh_auto_configure -- -DAUTOPLUGINS=1

override_dh_makeshlibs:
	# don't call as we only have plugins

=== debian/watch ===
version=3

http://biord-software.org/downloads/ qdevelop-v(.*)\.tar\.gz
